import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

//GlobalKey
class EasyHub {
  OverlayEntry _entry;
  OverlayState _overlayState;
  List<OverlayEntry> _listAdd = [];
  String msg = 'loading';
  TextStyle _textStyle; //自定义
  static EasyHub _easyHub = new EasyHub();

  factory EasyHub() => _getInstance();
  static EasyHub get getInstance => _getInstance();
  static EasyHub _getInstance() {
    if (_easyHub == null) {
      _easyHub = new EasyHub();
    }
    return _easyHub;
  }

/*初始化话*/
  EasyHub._initernal() {}

  void _show(String msg, BuildContext context) {
    if (_overlayState == null) {
      _overlayState = Overlay.of(context);
    }
    _entry == null;
    if (_entry == null) {
      _entry = getLayer(context);
    }

    if (_easyHub._listAdd.contains(_entry) == false) {
      _overlayState.insert(_entry);
      _easyHub._listAdd.add(_entry);
    } else {
      _entry.remove();
      _easyHub._listAdd.remove(_entry);
      _overlayState.insert(_entry);
      _easyHub._listAdd.add(_entry);
    }
  }

  void _dismiss() {
    if (_easyHub._listAdd.contains(_entry) && _entry != null) {
      _entry?.remove();
      _easyHub._listAdd.remove(_entry);
    }
  }

  static void dismiss() {
    EasyHub.getInstance._dismiss();
  }

  static void show(String msg, BuildContext context) {
    EasyHub.getInstance._show(msg, context);
  }

  OverlayEntry getLayer(BuildContext context) {
    Size _size = MediaQuery.of(context).size;
    Text _text = Text(
      this.msg,
      style: _textStyle == null
          ? TextStyle(
              fontSize: 15,
              color: Colors.white,
              decoration: TextDecoration.none)
          : _textStyle,
    );

    Widget _indicator = CircularProgressIndicator();
    double textHeight = _text.data.length > 0 ? 20 : 0;
    return OverlayEntry(
        maintainState: true,
        builder: (BuildContext con) {
          return Positioned(
            top: _size.height / 2 - 30,
            width: _size.width - 40,
            left: 20,
            height: 60 + textHeight,
            child: ClipRRect(
              borderRadius: BorderRadius.circular(5.0),
              child: Column(
                children: <Widget>[
                  Container(
                      height: 60,
                      alignment: Alignment.center,
                      color: Colors.black38,
                      child: _indicator),
                  Container(
                    height: textHeight,
                    alignment: Alignment.center,
                    color: Colors.black38,
                    child: _text,
                  ),
                ],
              ),
            ),
          );
        });
  }
}
